//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://emule.sf.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

// handling incoming connections (up or downloadrequests)

#pragma once
#include "preferences.h"
#include "packets.h"
#include "baseclient.h"

class CBaseClient;
class CPacket;

class CClientReqSocket : public CAsyncSocket{
public:
	CClientReqSocket(CPreferences* in_prefs,bool connected, CBaseClient* in_client = 0);
	~CClientReqSocket();
	virtual void OnClose(int nErrorCode);
	virtual void OnReceive(int nErrorCode);
	virtual	void OnConnect(int nErrorCode);
	virtual void OnSend(int nErrorCode);
	virtual int	 Send(const void*lpBuf,int nBufLen,int nFlags = 0,bool safesend = true);
	void		 Disconnect();
	bool	SendPacket(Packet* packet,bool delpacket = true);
	bool	IsBusy()	{return isbusy;}
	bool	IsConnected()	{return connected;}
	bool	IsDisconnected(){return disconnected;}
	void	SendHelloPacket();
private:
	bool	ProcessPacket(char* packet, uint32 size,uint8 opcode);
	bool	headercomplete;
	bool	isbusy;
	int32	sizetoget;
	int32	sizereceived;
	char*	rbuffer;
	CBaseClient* client;
	CPreferences* app_prefs;
	Packet*	pendingpacket;
	char*	pendingbuffer;
	uint32	pendingblen;
	bool	connected;
	bool	disconnected;
};

// CListenSocket command target

class CListenSocket : public CAsyncSocket{
public:
	CListenSocket(CPreferences* in_prefs);
	~CListenSocket();
	bool	StartListening();
	virtual void OnAccept(int nErrorCode);
private:
	CPreferences* app_prefs;
};


