//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://emule.sf.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#pragma once
#include "types.h"
#include "opcodes.h"
#include "uploadclient.h"
#include "preferences.h"

class CUploadQueue{
public:
	CUploadQueue(CPreferences* in_prefs);
	~CUploadQueue();
	void	Process();
	void	AddClientToQueue(CUploadClient* client);
	bool	RemoveFromUploadQueue(CUploadClient* client);
	bool	IsOnUploadQueue(CUploadClient* client)	{return GetWaitingClient(client);}
	bool	IsDownloading(CUploadClient* client)	{return GetDownloadingClient(client);}
	uint32	GetDatarate()							{return datarate;}
private:
	POSITION	GetWaitingClient(CUploadClient* client);
	POSITION	GetWaitingClientByIP(uint32 ip);
	POSITION	GetDownloadingClient(CUploadClient* client);
	bool		AcceptNewClient();
	void		AddUpNextClient(CUploadClient* directadd = 0);
	CTypedPtrList<CPtrList, CUploadClient*> waitinglist;
	CTypedPtrList<CPtrList, CUploadClient*> uploadinglist;
	CPreferences* app_prefs;
	UINT_PTR h_timer;
	uint32	datarate;   //datarate 1000ms average
	uint32	dataratems;	// datarate 100ms
	uint32	dataratetmp;
	uint32	datarateave; //datarage average (since progstart)
	sint32	estadatarate; // esta. max datarate
	uint8	count;

};
static uint32 i;
VOID CALLBACK TimerProc(HWND hwnd, UINT uMsg,UINT_PTR idEvent,DWORD dwTime);
